package Client;

import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;

import Remote_Interface.HelloInterface;

/**
 * Client 用于连接 并访问 服务端Server
 * @author SoFlash - 博客园 http://www.cnblogs.com/longwu
 */
public class Client {

    public static void main(String[] args) {
        // 定义一个端口号 该端口号必须与服务端的端口号相同
        int port = 6666;
        // 同样定义一个远程地址 该地址为服务端的远程地址 所以 与服务端的地址是一样的
        String address = "rmi://localhost:" + port + "/hello";

        // 在RMI注册表上需找 对象为HelloInterface的地址 即服务端地址 
        try {
            HelloInterface hInterface = (HelloInterface) Naming.lookup(address);
            // 一旦客户端找到该服务端地址 则 进行连接
            System.out.println("<<<客户端访问成功!");
            //客户端 Client 调用 远程接口里的 sayHello 方法  并打印出来
            System.out.println(hInterface.sayHello("SoFlash")); 
        } catch (MalformedURLException e) {
            System.out.println("错误的地址!");
            e.printStackTrace();
        } catch (RemoteException e) {
            System.out.println("创建远程对象出错!");
            e.printStackTrace();
        } catch (NotBoundException e) {
            System.out.println("未绑定的远程对象!");
            e.printStackTrace();
        } 
    }
}