package Server;

import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

import Remote_Interface.HelloInterface;
/**
 * HelloInterfaceImpl 用于实现 接口HelloInterface 的远程 SayHello方法
 * @author SoFlash - 博客园  http://www.cnblogs.com/longwu
 */
@SuppressWarnings("serial")
// 继承 UnicastRemoteObject 远程对象    这个一定要写 否则 服务端启动报异常
public class HelloInterfaceImpl extends UnicastRemoteObject implements HelloInterface{
    
    //HelloInterfaceImpl的构造方法 用于抛出UnicastRemoteObject 远程对象里的异常
    protected HelloInterfaceImpl() throws RemoteException {
    }

    public String sayHello(String name) throws RemoteException {
        //该信息 在客户端上发出
        String strHello = "你好! " + name+" 欢迎访问服务端!";
        //这条信息 是在服务端上 打印出来
        System.out.println(name +" 正在 访问本服务端!");
        return strHello;
    }
}