package Server;

import java.net.MalformedURLException;
import java.rmi.AlreadyBoundException;
import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;

import Remote_Interface.HelloInterface;

/**
 * Server 类 用于 启动 注册服务端
 * @author SoFlash - 博客园 http://www.cnblogs.com/longwu
 */
public class Server {

    public static void main(String[] args) {
        try {
            // 定义远程接口HelloInterface 对象 用于绑定在服务端注册表上 该接口由HelloInterfaceImpl()类实现
            HelloInterface hInterface = new HelloInterfaceImpl();
            int port = 6666; // 定义一个端口号
            // 创建一个接受对特定端口调用的远程对象注册表 注册表上需要接口一个指定的端口号
            LocateRegistry.createRegistry(port);
            // 定义 服务端远程地址 URL格式
            String address = "rmi://localhost:" + port + "/hello";
            // 绑定远程地址和接口对象
            Naming.bind(address,hInterface);
            // 如果启动成功 则弹出如下信息
            System.out.println(">>>服务端启动成功");
            System.out.println(">>>请启动客户端进行连接访问");
        } catch (MalformedURLException e) {
            System.out.println("地址出现错误!");
            e.printStackTrace();
        } catch (AlreadyBoundException e) {
            System.out.println("重复绑定了同一个远程对象!");
            e.printStackTrace();
        } catch (RemoteException e) {
            System.out.println("创建远程对象出现错误!");
            e.printStackTrace();
        }
    }
}